//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FormMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VirtualTrees"
#pragma resource "*.dfm"
TfrmMain *frmMain;
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
	////////////////////////////////////////////////////////////////////////////
	HWND hRegionMain, hRegionTitle, hRegionSystem ;

	hRegionTitle = CreateRectRgn(0, 0, TITLE_WIDTH, TITLE_HEIGHT);                   //  

	hRegionMain = CreateRectRgn(0, TITLE_HEIGHT, MAIN_WIDTH, TITLE_HEIGHT + MAIN_HEIGHT);

	hRegionSystem = CreateRectRgn(MAIN_WIDTH - SYSTEM_WIDTH,
								  TITLE_HEIGHT + MAIN_HEIGHT,
								  MAIN_WIDTH,
								  TITLE_HEIGHT + MAIN_HEIGHT + SYSTEM_HEIGHT);



	CombineRgn(hRegionMain, hRegionTitle, hRegionMain, RGN_OR);                 // 
	CombineRgn(hRegionSystem, hRegionMain, hRegionSystem, RGN_OR);                 // 

	SetWindowRgn(Handle, hRegionSystem, True);                                        //  

	Brush->Style = bsSolid;//bsClear;                                                       // 귯 Ÿ ..
  //	Pen->Style = psSolid;

	VST->BackgroundOffsetX = (VST->Width - VST->Background->Bitmap->Width) / 2;
	VST->BackgroundOffsetY = (VST->Height - VST->Background->Bitmap->Height) / 2;

	// ð  Լ ʱȭ..
	randomize();
   //	srand(GetTickCount());
	getIniFileSection();														// ComboBox ʱȭ..
    getIniFileData();														    // INI   .  
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::shpTitleMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
	if(bDragState)
	{
		this->Left = this->Left + X - nMouseDownX;
		this->Top = this->Top + Y - nMouseDownY;
	}
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::shpTitleMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	nMouseDownX = X;
	nMouseDownY = Y;
	bDragState = true;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::shpTitleMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
	bDragState = false;
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::VSTCreateEditor(TBaseVirtualTree *Sender,
      PVirtualNode Node, TColumnIndex Column, IVTEditLink *EditLink)
{
    if (!Node) return;

    TPropertyEditLink* PropertyLink;
	structIniData *pIniData = (structIniData *)Sender->GetNodeData(Node);

	if (pIniData)
	{
		if (pIniData->Colunms[2].PropertyTyp == ptCombo)
		{

			TStringList* MyList = new TStringList();
			try
			{
				MyList->Add("YES");
				MyList->Add("NO");

				PropertyLink = new TPropertyEditLink((TVirtualStringTree*)Sender, Node, Column, &(pIniData->Colunms[Column]), MyList);
			}
			__finally
			{
				delete MyList;
			}

		}
		else
			PropertyLink = new TPropertyEditLink((TVirtualStringTree*)Sender, Node, Column, &(pIniData->Colunms[Column]));


		PropertyLink->QueryInterface(__uuidof(IVTEditLink), (void**)EditLink);
	}	
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::VSTEditing(TBaseVirtualTree *Sender,
      PVirtualNode Node, TColumnIndex Column, bool &Allowed)
{
	Allowed = false;

	if (!Node) return;                                                //  only for safety the program !

	structIniData * pIniData = (structIniData *)Sender->GetNodeData(Node);
	if (pIniData)
		Allowed = (pIniData->Colunms[Column].PropertyTyp != ptNoOne);
	
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::VSTGetNodeDataSize(TBaseVirtualTree *Sender,
      int &NodeDataSize)
{
	NodeDataSize = sizeof(structIniData);
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::VSTGetText(TBaseVirtualTree *Sender,
      PVirtualNode Node, TColumnIndex Column, TVSTTextType TextType,
      WideString &CellText)
{
    if (!Node)
        return;

	structIniData *pIniData = (structIniData *)Sender->GetNodeData(Node);

	CellText = pIniData->Colunms[Column].Value; 	
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::VSTKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if( Shift.Contains(ssCtrl) && Shift.Contains(ssAlt))
	{
		VST->Clear();
	}
	else if(Shift.Contains(ssCtrl))                                                         // Ctrl Key  ̸..
	{
		VST->DeleteSelectedNodes();                              // õ  ...
	}
	else if(Shift.Contains(ssAlt) )                                                   // Alt Key  ̸..     ߰..
	{

	}	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::Button3Click(TObject *Sender)
{
	PostQuitMessage(-1);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::getIniFileSection()                                   //   
{
   // ޺ڽ ʱȭ...
	iniFile = new TIniFile(".\\Setup.ini");

	TStringList *lstSection = new TStringList;
	iniFile->ReadSections(lstSection);

	for(int i = 0; i < lstSection->Count; i++)                                  // Ȯڰ... "_"  ʴ°͸ Ʈ ø..
	{
		if( (lstSection->Strings[i].Trim()).Pos("_EXPLAIN") == 0 ||
		    (lstSection->Strings[i].Trim()).Pos("_DIVISION") == 0  )
			cbSection->Items->Add(lstSection->Strings[i]);
	}
	cbSection->ItemIndex = 0;

}
void __fastcall TfrmMain::getIniFileData()                                           // Ini  .
{
	VST->Clear();																// ʱȭĿ ׸..

	PVirtualNode Node;
	structIniData *pIniData;
	
	iniFile = new TIniFile(".\\Setup.ini" );

	if(cbSection->Text == "")
	{
		MessageDlg("Combo Box  Ͽ ֽʽÿ.", mtWarning, TMsgDlgButtons() << mbOK, 0);
        return;
	}

	TStringList *lstKey = new TStringList;
	iniFile->ReadSection(cbSection->Text, lstKey);                              // Ư Ʒ  key о
 //  MessageDlg(sizeof(lstKey) , mtWarning, TMsgDlgButtons() << mbOK, 0);
//	MessageDlg(lstKey->Count , mtWarning, TMsgDlgButtons() << mbOK, 0);
	Node = VST->AddChild(NULL);
 
	if (Node)
	{

		pIniData = (structIniData *)VST->GetNodeData(Node);

		for (int nNum = 0; nNum < lstKey->Count ; nNum++)
		{

			pIniData->Colunms[0].Value = cbSection->Text;
			pIniData->Colunms[0].PropertyTyp = ptNoOne;
			pIniData->Colunms[0].Changed = false;

			pIniData->Colunms[1].Value = lstKey->Strings[nNum];
			pIniData->Colunms[1].PropertyTyp = ptNoOne;
			pIniData->Colunms[1].Changed = false;

			pIniData->Colunms[2].Changed = false;

			pIniData->Colunms[3].Value = iniFile->ReadString(cbSection->Text + "_EXPLAIN",  lstKey->Strings[nNum], "0");
			pIniData->Colunms[3].PropertyTyp = ptNoOne;
			pIniData->Colunms[3].Changed = false;

			pIniData->Colunms[4].Value = iniFile->ReadString(cbSection->Text + "_DIVISION",  lstKey->Strings[nNum], "0");


			if(pIniData->Colunms[4].Value == "int" || pIniData->Colunms[4].Value == "long")
			{
				pIniData->Colunms[2].Value = (String)(iniFile->ReadInteger(cbSection->Text,  lstKey->Strings[nNum], 0));
				pIniData->Colunms[2].PropertyTyp = ptEdit;
			}
			else if(pIniData->Colunms[4].Value == "double" || pIniData->Colunms[4].Value == "float")
			{
				pIniData->Colunms[2].Value = (String)(iniFile->ReadFloat(cbSection->Text,  lstKey->Strings[nNum], 0.0));
				pIniData->Colunms[2].PropertyTyp = ptEdit;
			}
			else if(pIniData->Colunms[4].Value == "date")
			{
				pIniData->Colunms[2].Value = iniFile->ReadString(cbSection->Text,  lstKey->Strings[nNum], "2008-01-01");
				pIniData->Colunms[2].PropertyTyp = ptDate;
			}
			else if(pIniData->Colunms[4].Value == "time")
			{
				pIniData->Colunms[2].Value = iniFile->ReadString(cbSection->Text,  lstKey->Strings[nNum], "00:00:00");
				pIniData->Colunms[2].PropertyTyp = ptEdit;
			}
			else if(pIniData->Colunms[4].Value == "bool")
			{
				if(iniFile->ReadBool(cbSection->Text,  lstKey->Strings[nNum], false) == false)
					pIniData->Colunms[2].Value = "YES";
				else
					pIniData->Colunms[2].Value = "NO";
				pIniData->Colunms[2].PropertyTyp = ptCombo;
			}
			else
			{
				pIniData->Colunms[2].Value = iniFile->ReadString(cbSection->Text,  lstKey->Strings[nNum], "0");
				pIniData->Colunms[2].PropertyTyp = ptEdit;
			}
			pIniData->Colunms[4].PropertyTyp = ptNoOne;
			pIniData->Colunms[4].Changed = false;

			if(nNum < lstKey->Count - 1)
			{
				Node = VST->AddChild(NULL);
				pIniData = (structIniData *)VST->GetNodeData(Node);
			}

			VST->Refresh();
		}

		if(iniFile)
			delete iniFile;                                       					//
	}
	else
	{
		MessageDlg(" !!", mtError, TMsgDlgButtons() << mbOK, 0);
	}
}
void __fastcall TfrmMain::cbSectionChange(TObject *Sender)
{
	getIniFileData();
}
//---------------------------------------------------------------------------



